//+------------------------------------------------------------------+
//|                                Real Woodie CCI Valeo Version.mq4 |
//|                Based on the code of Jason Robinson (jnrtrading). |
//|                                                                  |
//| After read the Woodie introductory document I started a search   |
//| for the right coloured CCI.                                      |
//| I cant find anyone in accomplish with the explanation of Woodie |
//| So, I take the code from another CCI, and I added                |
//| the center LSMA line according to the official explanation.      |
//| Everything you see is an exact copy like its explained in the   |
//| document new_woodie_do1. Specially the colors.                   |
//| If you have some doubts can obtain a copy                        |
//| from http://woodiescciclub.com/                                  |
//|                                                                  |
//| Linuxser 2007                                                    |
//| for any doubts or suggestions contact me on Forex-TSD forum      |
//+------------------------------------------------------------------+
#property copyright "Under The GNU General Public License"
#property link      "www.gnu.org"

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 Blue
#property indicator_width1 2
#property indicator_color2 Red
#property indicator_width2 2
#property indicator_color3 Gray
#property indicator_width3 2
#property indicator_color4 Yellow
#property indicator_width4 2
#property indicator_color5 Black
#property indicator_width5 2
#property indicator_color6 White
#property indicator_width6 2
#property indicator_color7 Lime
#property indicator_width7 1
#property indicator_color8 Crimson
#property indicator_width8 1



//#property indicator_level1 50
#property indicator_level1 100
//#property indicator_level3 150
#property indicator_level2 200
#property indicator_level3 -200
//#property indicator_level6 -150
#property indicator_level4 -100
//#property indicator_level8 -50
#property indicator_levelcolor DarkSlateGray
#property indicator_levelstyle STYLE_SOLID
#property indicator_levelwidth 1

//---- input parameters
extern int TrendCCI_Period = 14;
extern int EntryCCI_Period = 6;
extern int LSMAPeriod = 25;     // LSMA period
extern bool Automatic_Timeframe_Setting = true;
extern int M1_TrendCCI_Period = 50;
extern int M1_EntryCCI_Period = 14;
extern int M1_LSMA = 25;
extern int M5_TrendCCI_Period = 63;
extern int M5_EntryCCI_Period = 7;
extern int M5_LSMA = 34;
extern int M15_TrendCCI_Period = 336;
extern int M15_EntryCCI_Period = 84;
extern int M15_LSMA = 60;
extern int M30_TrendCCI_Period = 14;
extern int M30_EntryCCI_Period = 6;
extern int M30_LSMA = 25;
extern int H1_TrendCCI_Period = 84;
extern int H1_EntryCCI_Period = 21;
extern int H1_LSMA = 25;
extern int H4_TrendCCI_Period = 630;
extern int H4_EntryCCI_Period = 126;
extern int H4_LSMA = 25;
extern int D1_TrendCCI_Period = 105;
extern int D1_EntryCCI_Period = 21;
extern int D1_LSMA = 25;
extern int W1_TrendCCI_Period = 14;
extern int W1_EntryCCI_Period = 6;
extern int W1_LSMA = 25;
extern int MN_TrendCCI_Period = 14;
extern int MN_EntryCCI_Period = 6;
extern int MN_LSMA = 25;
int FromZero   = 0;      // Distance from zero level
int EMAPeriod  = 34;     //  period



double TrendCCI[];
double EntryCCI[];
double CCITrendUp[];
double CCITrendDown[];
double CCINoTrend[];
double CCITimeBar[];
double LSMABuffer1[];
double LSMABuffer2[];
double ZeroLine[];
double LineHighEMA[];
double LineLowEMA[];

int trendUp, trendDown;



//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()  
   {   
//---- indicators
   SetIndexStyle(4, DRAW_LINE, STYLE_SOLID, 2);
   SetIndexBuffer(4, TrendCCI);
   SetIndexLabel(4, "TrendCCI");
   
   SetIndexStyle(0, DRAW_HISTOGRAM, 0);
   SetIndexBuffer(0, CCITrendUp);
   SetIndexLabel (0, NULL);
   
   SetIndexStyle(1, DRAW_HISTOGRAM, 0);
   SetIndexBuffer(1, CCITrendDown);
   SetIndexLabel (1, NULL);
    
   SetIndexStyle(2, DRAW_HISTOGRAM, 0);
   SetIndexBuffer(2, CCINoTrend);
   SetIndexLabel (2, NULL);
   
   SetIndexStyle(3, DRAW_HISTOGRAM, 0);
   SetIndexBuffer(3, CCITimeBar);
   SetIndexLabel (3, NULL);
   
   SetIndexStyle(5, DRAW_LINE, STYLE_SOLID, 1);
   SetIndexBuffer(5, EntryCCI);
   SetIndexLabel(5, "EntryCCI");
      
   SetIndexStyle (6, DRAW_ARROW, 0);
   SetIndexBuffer(6, LSMABuffer2);
   SetIndexLabel (6, NULL);    
   SetIndexEmptyValue(6,EMPTY_VALUE);
   SetIndexArrow(6,167); 
    
   SetIndexStyle (7, DRAW_ARROW, 0);     
   SetIndexBuffer(7, LSMABuffer1);
   SetIndexLabel (7, NULL);
   SetIndexEmptyValue(7,EMPTY_VALUE);
   SetIndexArrow(7,167);  
   
    
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {

   int limit, i, trendCCI, entryCCI;
   int counted_bars = IndicatorCounted();
   static datetime prevtime = 0;
//---- check for possible errors
   if(counted_bars < 0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars > 0) counted_bars--;

   limit=Bars;//-counted_bars;   
   
   if (Automatic_Timeframe_Setting == true) {
      switch(Period()) {
         case 1: trendCCI = M1_TrendCCI_Period; entryCCI = M1_EntryCCI_Period; LSMAPeriod = M1_LSMA ;break;
         case 5: trendCCI = M5_TrendCCI_Period; entryCCI = M5_EntryCCI_Period; LSMAPeriod = M5_LSMA ;break;
         case 15: trendCCI = M15_TrendCCI_Period; entryCCI = M15_EntryCCI_Period; LSMAPeriod = M15_LSMA ;break;
         case 30: trendCCI = M30_TrendCCI_Period; entryCCI = M30_EntryCCI_Period;LSMAPeriod = M30_LSMA ; break;
         case 60: trendCCI = H1_TrendCCI_Period; entryCCI = H1_EntryCCI_Period; LSMAPeriod = H1_LSMA ;break;
         case 240: trendCCI = H4_TrendCCI_Period; entryCCI = H4_EntryCCI_Period; LSMAPeriod = H4_LSMA ;break;
         case 1440: trendCCI = D1_TrendCCI_Period; entryCCI = D1_EntryCCI_Period; LSMAPeriod = D1_LSMA ;break;
         case 10080: trendCCI = W1_TrendCCI_Period; entryCCI = W1_EntryCCI_Period; LSMAPeriod = W1_LSMA ;break;
         case 43200: trendCCI = MN_TrendCCI_Period; entryCCI = MN_EntryCCI_Period; LSMAPeriod = MN_LSMA ;break;
         }
         }
   else {
   trendCCI = TrendCCI_Period;
   entryCCI = EntryCCI_Period;
       
   }    
  
   IndicatorShortName("(CCI: " + trendCCI + ", TCCI: " + entryCCI + ", LSMA: " + LSMAPeriod + ") ) ");   
   
   for(i = limit; i >= 0; i--) {
      CCINoTrend[i] = 0;
      CCITrendDown[i] = 0;
      CCITimeBar[i] = 0;
      CCITrendUp[i] = 0;
      ZeroLine[i] = 0;
      TrendCCI[i] = iCCI(NULL, 0, trendCCI, PRICE_WEIGHTED, i);
      EntryCCI[i] = iCCI(NULL, 0, entryCCI, PRICE_WEIGHTED, i);
      
      if(TrendCCI[i] > 0 && TrendCCI[i+1] < 0) {
         if (trendDown > 4) trendUp = 0;
      }
      if (TrendCCI[i] > 0) {
         if (trendUp < 5){
            CCINoTrend[i] = TrendCCI[i];
            trendUp++;
         }
         if (trendUp == 5) {
            CCITimeBar[i] = TrendCCI[i];
            trendUp++;
         }
         if (trendUp > 5) {
            CCITrendUp[i] = TrendCCI[i];
         }
      }
      if(TrendCCI[i] < 0 && TrendCCI[i+1] > 0) {
         if (trendUp > 4) trendDown = 0;
      }
      if (TrendCCI[i] < 0) {
         
         if (trendDown < 5){
            CCINoTrend[i] = TrendCCI[i];
            trendDown++;
         }
         if (trendDown == 5) {
            CCITimeBar[i] = TrendCCI[i];
            trendDown++;
         }
         if (trendDown > 5) {
            CCITrendDown[i] = TrendCCI[i];
         }
      }
   }
   
//---- Color Middle Line LSMA
  
  double sum, lengthvar, tmp, wt;
  int shift;
  int Draw4HowLong, loopbegin;

  if (counted_bars<0) return;
  if (counted_bars>0) counted_bars--;
  counted_bars = Bars - counted_bars;
  for (shift=0; shift<counted_bars; shift++) {
    LineLowEMA[shift] = -FromZero;
    LineHighEMA[shift] = -FromZero;

    double EmaValue = iMA(NULL, 0, EMAPeriod, 0, MODE_LWMA, PRICE_WEIGHTED, shift);
    if (Close[shift]>EmaValue) LineHighEMA[shift] = EMPTY_VALUE;
    if (Close[shift]<EmaValue) LineLowEMA[shift] = EMPTY_VALUE;
  }

  Draw4HowLong = Bars-LSMAPeriod - 5;
  loopbegin = Draw4HowLong - LSMAPeriod - 1;

  for(shift=loopbegin; shift>=0; shift--) {
    sum = 0;
    for (i=LSMAPeriod; i>=1; i--) {
      lengthvar = LSMAPeriod + 1;
      lengthvar /= 3;
      tmp = 0;
      tmp = (i - lengthvar) * Close[LSMAPeriod-i+shift];
      sum+=tmp;
    }
    wt = sum * 6 / (LSMAPeriod * (LSMAPeriod + 1));

    LSMABuffer1[shift] = 0;
    LSMABuffer2[shift] = 0;

    if (wt>Close[shift]) LSMABuffer2[shift] = EMPTY_VALUE;
    if (wt<Close[shift]) LSMABuffer1[shift] = EMPTY_VALUE;
  }

//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+